
public class SMSApu
{
	private apu_rectangle chan[];
	private apu_noise chan3;
	private apu_rectangle apu_current;
	private PSGi psgi;

	public void init()
	{
		chan = new apu_rectangle[3];

		chan[0] = new apu_rectangle();
		chan[1] = new apu_rectangle();
		chan[2] = new apu_rectangle();
		chan3   = new apu_noise(chan[2]);
	}

	public void writeReg(int value)
	{
		//if (port == 0x06) // GG stereo
		//{
		//	setPan(value);
		//	return;
		//}
		if ((value & 0x80) == 0x80)
		{
			if ((value & 0x60) != 0x60) // Tone Channel
			{
				if ((value & 0x10) == 0x10)
					chan[value>>5&0x3].setVolume(value&0x0F);
				else
					chan[value>>5&0x3].first_byte = value & 0x0F;
				apu_current = chan[value>>5&0x3];
			}
			else // Noise Channel
			{
				if ((value & 0x10) == 0x10)
					chan3.setVolume(value&0xF);
				else
					chan3.setFreq(value&0x07);
				apu_current = null;
			}
		}
		// Latch
		else if (apu_current != null)
			apu_current.setFreq(value);
	}

	public void doFrame()
	{
		if (chan3.white_noise)
			psgi.setToneBank(15, 127);
		else
			psgi.setToneBank(15, 80);

		psgi.setChFreq(0, chan[0].frequency);
		psgi.setChFreq(1, chan[1].frequency);
		psgi.setChFreq(2, chan[2].frequency);
		psgi.setChFreq(3, chan3.frequency);
		psgi.setChVolume(0, chan[0].volume);
		psgi.setChVolume(1, chan[1].volume);
		psgi.setChVolume(2, chan[2].volume);
		psgi.setChVolume(3, chan3.volume);

		psgi.doFrame();
	}


	class apu_rectangle
	{
		public int volume;
		public int frequency;
		public int first_byte;

		private final int[] vol =
		{
		   46, 44, 42, 40, 38, 36, 34, 32,
		   28, 25, 22, 19, 14, 10,  7,  0
		};

		public void init()
		{
			volume = 0;
			frequency = 1;
			first_byte = 0;
		}

		public void setFreq(int value)
		{
			int i = (value & 0x3F) << 4 | first_byte;
			frequency = i > 0 ? 3579545 / (32 * i) : 1;
		}

		public void setVolume(int value)
		{
			volume = vol[value];
		}

		public apu_rectangle()
		{
			init();
		}
	}

	class apu_noise
	{
		private apu_rectangle chan2;

		public int volume;
		public int frequency;

		public boolean white_noise;

		private final int HIGH = 7800;
		private final int MEDIUM = 3900;
		private final int LOW = 1950;

		private final int[] vol =
		{
		   46, 44, 42, 40, 38, 36, 34, 32,
		   28, 25, 22, 19, 14, 10,  7,  0
		};

		public void init()
		{
			volume = 0;
			frequency = 1;
			white_noise = false;
		}

		public void setFreq(int value)
		{
			white_noise = ((value & 0x4) == 0x4);

			switch (value&0x3)
			{
				case 0x00 :
					frequency = HIGH;
					break;
				case 0x01 :
					frequency = MEDIUM;
					break;
				case 0x02 :
					frequency = LOW;
					break;
				case 0x03 :
					frequency = chan2.frequency;
					break;
				default :
			}
		}

		public void setVolume(int value)
		{
			volume = vol[value];
		}

		public apu_noise(apu_rectangle chan2)
		{
			this.chan2 = chan2;
			init();
		}
	}


	public SMSApu(PSGi psgi)
	{
		this.psgi = psgi;
	}
}