import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.util.Calendar;
import javax.microedition.io.Connector;
import com.nttdocomo.system.ImageStore;
import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.TextBox;
import com.nttdocomo.ui.Dialog;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.Font;
import com.nttdocomo.ui.Frame;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.Image;
import com.nttdocomo.ui.MediaImage;
import com.nttdocomo.ui.MediaManager;
import com.nttdocomo.ui.ImageEncoder;
import com.nttdocomo.ui.EncodedImage;

public final class SMSCanvas extends Canvas {

	private static final String INFO_STR	= 
		"    uoShoelace"	+ "\n" +
		"     ver0.33a  "	+ "\n"
							+ "\n" +
		" is made based on" + "\n" +
		"     Shoelace" 	+ "\n" +
		"     by Mr.407"	+ "\n"
							+ "\n" +
		"Thanks All Author!"+ "\n"  
	;
	private static final String SOFTKEY_ROOT_STR	= "MENU";
	private static final String SOFTKEY_ROM_STR		= "̕ҏW";
	private static final String SOFTKEY_RESET_STR	= "RESET";
	private static final String SOFTKEY_EXIT_STR	= "I";
	private static final String SOFTKEY_RET_STR		= "߂";
	private static final String SOFTKEY_GAME_STR	= "GAME";
	private static final String SOFTKEY_SAVE_STR	= "폜";
	private static final String SOFTKEY_KEYSET_STR	= "ݒر";
	private static final String SOFTKEY_PAD_STR		= "PADݒ";

	private static final String[]

	SOFTKEY_SOUND_STR  = new String[] {" ~ ", "  "},
	ON_OFF_STR	= new String[] { "OFF", "ON" },
	FRAMES_STR	= new String[] { "OFF", "LIMIT", "AUTO" },
	FLIPMODE_STR= new String[] { "ʏ", "E90", "180", "90" },
	SOUND_STR	= new String[] { "PRESET", "YAMAHA", "ROHM" },
	CTRL_STR	= new String[] { "1P", "1P/2P", "2P" },
	SOFTKEY_BGCOLOR_STR = new String[] { "BLUE", "RED", "BLACK", "BLUE+", "RED+", "BLACK+" },
	SOFTKEY_STR = new String[] { "pbhݒ", "Zbg", "TEh" },

	KEY_NAME	= new String[] { "0", "1", "2", "3", "4", "5", "6", "7",
					 "8", "9", "*", "#", "12", "13", "14", "15",
					 "LEFT", "UP", "RIGHT", "DOWN", "SELECT", "SOFT1", "SOFT2", "23",
					 "IAPP", "25", "UPPER_LEFT", "UPPER_RIGHT", "LOWER_RIGHT", "LOWER_LEFT", "PAGE_UP", "PAGE_DOWN",
					 "CLEAR", "MAIL", "MEMO", "MENU", "IMODE", "PHONEBOOK", "CALENDAR", "VOICE",
					 "MANNER", "DRIVE", "GPS", "43", "44", "45", "46", "47",
					 "ROLL_LEFT", "ROLL_RIGHT", "SUB1", "SUB2", "SUB3", "MY_SELECT", "54", "55",
					 "CAMERA", "ZOOM_IN", "ZOOM_OUT", "CAMERA_SELECT", "CAMERA_LIGHT", "CAMERA_SHOT", "62", "-"},

	GM_PRESET_STR	= new String[] { "square", "piano 1", "piano 2", "piano 3", "piano 4", "piano 5", "piano 6",
					 "cembalo", "clavi", "celesta", "glockenspiel", "orgel", "vibraphone", "marimba", "xylophone" },

	GM_NP_STR	= new String[] { "square 12.5%", "square 25%", "square 50%", "triangle", "noise" };

	private static final int MODE_MENU_ROOT =  0;
	private static final int MODE_MENU_ROM =  1;
	private static final int MODE_MENU_LOAD =  2;
	private static final int MODE_MENU_SAVE =  3;
	private static final int MODE_MENU_SETTING =  4;
	private static final int MODE_MENU_AUDIO_SET =  5;
	private static final int MODE_PAD_SET =  6;
	private static final int MODE_MENU_BUTTON_SET = 7;
	private static final int MODE_MENU_ROMFILE = 8;
	private static final int MODE_GAME = 9;
	private static final int MODE_PAD_SET_NOW = 10;
	private static final int MODE_MENU_CONFIRM = 11;
	private static final int MODE_MENU_TOOLS = 12;
	private static final int MODE_MENU_EXPORT = 13;
	private static final int MODE_MENU_IMPORT = 14;

	/** ScratchPadpo[W */
	private static final int VERSION	= 40;
	/** Z[uf[^ */
	private static final int NUM_SAVE	= 12;
	/** y[WSDROM */
	private static final int NUM_SDROM	= 12;
	/** őSDROM y[W. */
	private static final int MAX_SDROM_PAGE	= 20;
	/** Z[uf[^P̃TCY */
	private static final int SIZE_SAVE	= 1024 * 65;
	/** ݒۑp̃TCY */
	private static final int SIZE_SP_OTHERS	=  150;
	private static final int SIZE_SP_KEYS	=  200;
	private static final int SIZE_SP_SAVES	=  500;
	private static final int SIZE_SP_RESERVE=  150;
	private static final int SIZE_SP_SET	= 1000;
	// Save1̖OB{Game
	private static final int SIZE_SAVE_NAME	=   34;
	// ROM̒
	private static final int SIZE_ROM_NAME	=   30;

	/* Exportp1Block̃TCY */
	private static final int EXPORT_BLOCK_SIZE = 255;

	private static final int[] GM_PRESET_NUM	= new int[] { 80, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 };
	private static final int[] GM_NP_NUM	= new int[] { 0, 1, 2, 3, 4 };

	/////////////////////////////////
	// ݒ荀
	/////////////////////////////////
	// NtO
	private boolean firstExec_ = false;
	// fps
	int fps_ = 0;
	// fps\邩ǂB
	private boolean fpsOff_;
	// NɑOROMǂݍނB
	private int startAndLoad_ = 0;
	// t[XLbv
	private int frameSkip_ = 5;
	// x(60FPS)
	private int sleep_ = 0;
	// ʉ](0:ʏA1:EA2:180A3:)
	private int flipMode_ = 0;
	// E\tgL[̋@\
	private int rSoftkey_ = 0;
	// mFbZ[W
	private int confirmMsg_ = 0;
	// j[wiF
	private int menuBGcolor_ = 0;
	// j[̓
	private boolean alpha_;
	// Z80Ԉ
	private int cpuOmit_ = 0;
	// GGʊg
	private int zoom_ = 0;
	//g\Aڂ邩ǂ
	public boolean Anti_Alias_ = true;
	// 
	private int vol_ = 0;
	//TEhIIt
	private boolean soundEnable_;
	// t[ɍĐ邩
	private int soundBufCount_ = 60;
	// F[h
	private int toneMode_ = 0;
	// F
	private int[] tone_preset_ = new int[3];
	private int[] tone_np_ = new int[3];
	// o̓`l
	private boolean[] chEnable_ = new boolean[4];
	// {^1A
	private int ren1_ = 0;
	// {^1z[h
	private int hold1_ = 0;
	// {^2A
	private int ren2_ = 0;
	// {^2z[h
	private int hold2_ = 0;
	// 2PRg[(00:1P, 01:1P/2P, 10:2P)
	private int con2_ = 0;
	// OSDROMԍ
	private int sdNo_ = 0;
	// SDt@Cy[W
	private int sdPage_ = 0;
	// SDROMt@CXg
	private String[] sdRomnm_ = new String[NUM_SDROM];
	// Save{Game
	private String[] saveStr_ = new String[NUM_SAVE];
	// E\tgL[}XN
	private int skeyMask_ = 0;
	// L[zu
	private int[] keycon_ = new int[12];
	// pbh@\ptO
	private boolean padDisp_ = false;
	private boolean displayClear;

	// rootj[Iԍ
	private int selectMenuNo_ = 0;
	// SubMenu
	private int selectSubMenuNo_ ;
	private int svSubMenuLoadNo;
	private int svSubMenuSaveNo;
	private int svSubMenuSettingNo;
	private int svSubMenuKeyConfNo;
	private int svSubMenuPadNo;
	private int svSubMenuToolNo;
	private int svSubMenuImportNo;
	private int svSubMenuExportNo;
	private int svSubMenuAudioNo;
	private int svSubMenuRomfileNo;
	private int svSubMenuConfirmNo;



	/////////////////////////////////
	// ̑CX^X
	/////////////////////////////////
	// NROMIʕ\
	private int mode_ = MODE_MENU_ROM;
	// JgROM
	private String curRom_ = "";
	// JgSDROMy[Wԍ
	private int page_ = 1;
	// SubMenuXg
	private String[] subMenu = new String[1];
	// SMS/GG[hؑ
	private boolean sms_ = true;
	// CoreғtO
	private boolean run_ = false;

	private SMSCore core;
	private PSGi psgi;
	private int frame_count, last_frame;
	private int skippedFrameCount;
	private long lastTime_, startTime_;
	private String messageStr = "";

	private Image[] img = new Image[2];
	private Image allImg = null;
	private Graphics allG = null;
	private Graphics g = this.getGraphics(); //setMessagep

	private byte[] GIF_HEADER = { 'G', // 0x47
		'I', // 0x49
		'F', // 0x46
		'8', // 0x38
		'9', // 0x39
		'a', // 0x61
		0x01,
			0x00,
			0x01,
			0x00,
			0x80 - 0x100,
			0x00,
			0x00,
			0xFF - 0x100,
			0xFF - 0x100,
			0xFF - 0x100,
			0x00,
			0x00,
			0x00,
			0x2C,
			0x00,
			0x00,
			0x00,
			0x00,
			0x01,
			0x00,
			0x01,
			0x00,
			0x00,
			0x02,
			0x02,
			0x44,
			0x01,
			0x00,
			0x21,
			0xFE - 0x100 };

	// Y[
	private int scale = 1; //ׂĂ̕menuGVGAo b1
	private int mscale = 1; //ʏʂ݂menuG̑傫@b1

	private final Font DEFAULT_FONT;
	private final int HEIGHT_LINE;
	private final int BASE_LINE;
	private int MENU_WIDTH;
	private int MENU_HEIGHT;

	public int width = getWidth();
	public int height = getHeight();

	{
		MENU_WIDTH = width * mscale;
		MENU_HEIGHT = height * mscale;
		DEFAULT_FONT = Font.getDefaultFont();
		// s = tHg + ̗] + ̗]
		HEIGHT_LINE = DEFAULT_FONT.getHeight() + 1 + 2 * 2;
		// x[X = ] + tHgAscent
		BASE_LINE = 3 + DEFAULT_FONT.getAscent();
	}

	SMSCanvas() {
		setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_RET_STR);
		setBackground(Graphics.getColorOfName(Graphics.BLACK));
		allImg = Image.createImage(240, 240);
		allG = allImg.getGraphics();
		try {
			MediaImage mi1 = MediaManager.getImage("resource:///gg.gif");
			MediaImage mi2 = MediaManager.getImage("resource:///title.gif");
			mi1.use();
			mi2.use();
			img[0] = mi1.getImage();
			img[1] = mi2.getImage();
		} catch (IOException e) {}

		// XNb`pbhǍ
		readSP();
		readSPkeys();
		readSPsaves();
		setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
		page_ = sdNo_ / NUM_SDROM + 1;
		selectSubMenuNo_ = sdNo_ % NUM_SDROM;
		readSdromNameSP(page_);

		psgi = new PSGi();
		psgi_set();
		core = new SMSCore(this, psgi);

		// OROMǂݍ
		if (startAndLoad_ == 1) {
			loadRom();
		}
	}

	public boolean startFrame() {
		frame_count++;
		if (sleep_  == 2) {
			double ftime,dtime;
			long ctime;
			if (frame_count % 61 == 0) {
				if (!fpsOff_) messageStr = (60 - skippedFrameCount) + "/60 frames.";
				skippedFrameCount = 0;
			}
			ctime = System.currentTimeMillis();
			ftime = startTime_ + 16.66666 * frame_count;
			dtime = ctime - ftime;
			if (dtime > 500 || dtime < -500) {
				startTime_ = System.currentTimeMillis();
				frame_count = 0;
				last_frame = 0;
			}
			if (ctime < ftime) {
				return true;
			} else {
				skippedFrameCount++;
				if(skippedFrameCount == 60)
					return true;
				else
					return false;
			}
		} else {
			return frame_count % frameSkip_ == 0;
		}
	}

	public void endFrame() {
		if (frame_count - last_frame >= 60) {
			long current = System.currentTimeMillis();
			fps_ = 60000 / (int) (current - lastTime_);
			last_frame += 60;
			lastTime_ = current;
			if (!fpsOff_ && sleep_ < 2) {
				if (fps_ < 10) messageStr = "  " + fps_ + "FPS : FS = " + frameSkip_;
				else if (fps_ < 100) messageStr = " " + fps_ + "FPS : FS = " + frameSkip_;
				else if (fps_ < 1000) messageStr = "" + fps_ + "FPS : FS = " + frameSkip_;
			}
		}
		repaint();

		// x(60FPS)
		if (sleep_ == 1) {
			long tm = startTime_ + (long)(1667 * frameSkip_ / 100);
			do {
				startTime_ = System.currentTimeMillis();
			} while (tm > startTime_);
			long delay = (startTime_ - tm);
			if (delay > 0 && delay < 50) {
				startTime_ -= delay;
			}
		}
	}

	public String getSaveFile(final int slot) {
		return "NO" + formatNumber(slot, 2) + ".SAV";
	}

	public final int getZoom() {
		return zoom_;
	}

	public void processEvent(final int type, final int param) {
		if (type != Display.KEY_PRESSED_EVENT) return;

		switch (mode_) {
			case MODE_GAME :
				switch (param) {
					case Display.KEY_SOFT1 :
						core.request(SMSCore.REQUEST_SLEEP, 0);
						mode_ = MODE_MENU_ROOT;
						setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_GAME_STR);
						setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_EXIT_STR);
						messageStr = "";
						repaint();
						break;
					case Display.KEY_SOFT2 :
							switch (rSoftkey_) {
								case 0 :
									core.request(SMSCore.REQUEST_SLEEP, 0);
									padDisp_ = true;
									setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_RET_STR);
									selectSubMenuNo_ = svSubMenuPadNo;
									mode_ = MODE_MENU_BUTTON_SET;
									repaint();
									break;
								case 1:
									boolean rYes = true;
									if ((confirmMsg_ & 4) != 0) {
										core.request(SMSCore.REQUEST_SLEEP, 0);
										rYes = confirm("Zbg܂H");
									}
									if (rYes) {
										core.request(SMSCore.REQUEST_RESET, 0);
									} else {
										core.request(SMSCore.REQUEST_START, 0);
									}
									break;
								case 2:
									soundEnable_ = !soundEnable_;
									setRightSoftkeyLabel();
									writeSP();
									psgi.setSoundEnable(soundEnable_);
									break;
							}
							break;
					default :
						if (param == keycon_[10]) {
							if (!sms_) {
								zoom_ = (zoom_ + 1) & 1;
								displayClear = true;
								writeSP();
							}
						} else if (param == keycon_[11]) {
							cpuOmit_ = (cpuOmit_ + 1) & 1;
							core.i_sw(cpuOmit_ == 1);
							writeSP();
						}
						break;
				}
				break;
			case MODE_PAD_SET_NOW :
				keySet(param);
				break;
			default :
				keyPressMenu(param);
				break;
		}
	}

	private void keyPressMenu(final int param) {
		String tmp;
		long wt = 700;
		long ct = 0;
		switch (param) {
			case Display.KEY_SOFT1 :
				if (mode_ != MODE_MENU_ROOT) {
					switch (mode_) {
						case MODE_MENU_AUDIO_SET :
							svSubMenuAudioNo = selectSubMenuNo_;
							selectSubMenuNo_ = 9;
							mode_ = MODE_MENU_SETTING;
							writeSP();
							break;
						case MODE_MENU_ROMFILE :
							svSubMenuRomfileNo = selectSubMenuNo_;
							selectSubMenuNo_ = 10;
							mode_ = MODE_MENU_SETTING;
							break;
						case MODE_MENU_CONFIRM :
							svSubMenuConfirmNo = selectSubMenuNo_;
							selectSubMenuNo_ = 11;
							mode_ = MODE_MENU_SETTING;
							break;
						case MODE_MENU_LOAD :
							svSubMenuLoadNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_SAVE :
							svSubMenuSaveNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_SETTING :
							svSubMenuSettingNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_BUTTON_SET:
							svSubMenuPadNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_TOOLS:
							svSubMenuToolNo = selectSubMenuNo_;
							mode_ = MODE_MENU_ROOT;
							break;
						case MODE_MENU_EXPORT :
							svSubMenuExportNo = selectSubMenuNo_;
							selectSubMenuNo_ = 0;
							mode_ = MODE_MENU_TOOLS;
							break;
						case MODE_MENU_IMPORT :
							svSubMenuImportNo = selectSubMenuNo_;
							selectSubMenuNo_ = 1;
							mode_ = MODE_MENU_TOOLS;
							break;
						default :
							mode_ = MODE_MENU_ROOT;
							messageStr = "";
					}
					if (mode_ == MODE_MENU_ROOT) {
						setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_GAME_STR);
						setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_EXIT_STR);
					}else if (mode_ == MODE_MENU_SETTING) {
						setSoftLabel( Frame.SOFT_KEY_2 ,SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
					} else {
						setSoftLabel(Frame.SOFT_KEY_2, null);
					}
				} else {
					messageStr = "";
					core.request(SMSCore.REQUEST_START, 0);
					setSoftLabel(Frame.SOFT_KEY_1, SOFTKEY_ROOT_STR);
					setRightSoftkeyLabel();
					displayClear = true;
					mode_ = MODE_GAME;
				}
				padDisp_ = false;
				repaint();
				break;

			case Display.KEY_SOFT2 :
				switch (mode_) {
					case MODE_MENU_ROOT :
						boolean rYes = true;
						if ((confirmMsg_ & 8) != 0) rYes = confirm("I܂H");
						if (rYes) {
							IApplication.getCurrentApp().terminate();
						}
						break;
					case MODE_MENU_ROM :  // ROM̕ҏW
						imeOn(sdRomnm_[selectSubMenuNo_].trim(), TextBox.DISPLAY_ANY, TextBox.KANA);
						break;
					case MODE_MENU_LOAD : // Z[uf[^̕ҏW
						tmp = saveStr_[selectSubMenuNo_].trim();
						if (!tmp.equals("")) imeOn(saveStr_[selectSubMenuNo_].trim(), TextBox.DISPLAY_ANY, TextBox.KANA);
						break;
					case MODE_MENU_SAVE : // Z[uf[^폜
						tmp = saveStr_[selectSubMenuNo_].trim();
						if (!tmp.equals("")){
							if (confirm("No." + (selectSubMenuNo_ + 1)
								+ "\n"
								+ saveStr_[selectSubMenuNo_]
								+ "\n폜܂H")) {
								messageStr = "f[^폜";
								setMessage(messageStr);
								SDbinding sd = new SDbinding();
								sd.deleteFile("NO" + formatNumber(selectSubMenuNo_ + 1, 2) + ".SAV");
								saveStr_[selectSubMenuNo_] = "";
								writeSPsaves(selectSubMenuNo_);
								messageStr = "";
								repaint();
							}
						}
						break;
					case MODE_MENU_SETTING :
						if (++menuBGcolor_ > 5) menuBGcolor_ = 0;
						setSoftLabel( Frame.SOFT_KEY_2 ,SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
						writeSP();
						repaint();
						break;
					case MODE_MENU_BUTTON_SET:
						if (padDisp_){
							svSubMenuPadNo = selectSubMenuNo_;
							setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_PAD_STR);
							padDisp_ = false;
							core.request(SMSCore.REQUEST_START, 0);
							displayClear = true;
							mode_ = MODE_GAME;
							repaint();
						}
						break;
					default :
						break;
				}
				break;

			case Display.KEY_1 :
			case Display.KEY_2 :
			case Display.KEY_3 :
			case Display.KEY_4 :
			case Display.KEY_5 :
			case Display.KEY_6 :
			case Display.KEY_7 :
			case Display.KEY_8 :
			case Display.KEY_9 :
			case Display.KEY_0 :
			case Display.KEY_ASTERISK :
			case Display.KEY_POUND :
				int pno;
				switch (param) {
					case Display.KEY_0 :
						pno = 10;
						break;
					case Display.KEY_ASTERISK :
					case Display.KEY_POUND :
						pno = param + 1;
						break;
					default :
						pno = param;
				}
				if (mode_ == MODE_MENU_ROOT) {
					if (pno > subMenu.length) {
						break;
					}
					selectMenuNo_ = pno - 1;
				} else {
					if (pno > subMenu.length) {
						break;
					}
					selectSubMenuNo_ = pno - 1;
				}
			// KEY_SELECT̓BbreakȂB
			case Display.KEY_SELECT :
				switch (mode_) {
					case MODE_MENU_ROOT :
						selectMenuRoot();
						break;
					case MODE_MENU_ROM :
						loadRom();
						break;
					case MODE_MENU_LOAD :
						stateLoad();
						break;
					case MODE_MENU_SAVE :
						stateSave();
						break;
					case MODE_MENU_EXPORT :
						tmp = saveStr_[selectSubMenuNo_].trim();
						if (tmp.equals("")){
							infomsg("Lȃf[^ł͂܂B");
						} else {
							messageStr = "f[^GIFo͒";
							setMessage(messageStr);
							exportGIF();
						}
						break;
					case MODE_MENU_IMPORT :
						messageStr = "f[^GIFǍ";
						setMessage(messageStr);
						importGIF();
						break;
					case MODE_MENU_SETTING :
						selectMenuSet();
						break;
					case MODE_MENU_AUDIO_SET :
						selectMenuSound();
						break;
					case MODE_PAD_SET :
						selectMenuKey();
						break;
					case MODE_MENU_BUTTON_SET :
						selectMenuPad();
						break;
					case MODE_MENU_ROMFILE :
						selectMenuSdset();
						break;
					case MODE_MENU_CONFIRM :
						selectMenuConfirm();
						break;
					case MODE_MENU_TOOLS :
						selectMenuTools();
						break;
					default :
				}
				if (mode_ == MODE_PAD_SET_NOW) {
					setSoftLabel( Frame.SOFT_KEY_2 , SOFTKEY_KEYSET_STR );
				}else if (mode_ != MODE_MENU_ROOT && mode_ != MODE_GAME) {
					setSoftLabel( Frame.SOFT_KEY_1 , SOFTKEY_RET_STR );
				}
				break;

			case Display.KEY_UP :
				while (getKeypadState() != 0){
					ct = System.currentTimeMillis();
					if (mode_ == MODE_MENU_ROOT) {
						selectMenuNo_ =
							incNo(selectMenuNo_, -1, subMenu.length);
					} else {
						selectSubMenuNo_ =
							incNo(selectSubMenuNo_, -1, subMenu.length);
					}
					repaint();
					while (System.currentTimeMillis() - ct < wt) {
						if (getKeypadState() == 0) break;
						try {
							Thread.sleep(10L);
						} catch (Exception ex) {}
					}
					wt = 180;
				}
				break;

			case Display.KEY_DOWN :
				while (getKeypadState() != 0){
					ct = System.currentTimeMillis();
					if (mode_ == MODE_MENU_ROOT) {
						selectMenuNo_ =
							incNo(selectMenuNo_, +1, subMenu.length);
					} else {
						selectSubMenuNo_ =
							incNo(selectSubMenuNo_, +1, subMenu.length);
					}
					repaint();
					while (System.currentTimeMillis() - ct < wt) {
						if (getKeypadState() == 0) break;
						try {
							Thread.sleep(10L);
						} catch (Exception ex) {}
					}
					wt = 180;
				}
				break;

			case Display.KEY_RIGHT :
				while (getKeypadState() != 0) {
					ct = System.currentTimeMillis();
					switch (mode_) {
						case MODE_MENU_ROM :
							if (page_ < sdPage_) page_++;
							else page_ = 1;
							readSdromNameSP(page_);
							break;
						case MODE_MENU_SETTING :
							if (selectSubMenuNo_ == 1){
								if (frameSkip_ < 30) frameSkip_++;
									else frameSkip_ = 1;
								writeSP();
							}
							break;
						case MODE_MENU_AUDIO_SET :
							int select = selectSubMenuNo_ + 1;
							if (select == 1) {
								if (vol_ < 100) vol_ += 10;
								else vol_ = 0;
							} else if (select == 2) {
								if (soundBufCount_ < 60) soundBufCount_ += 5;
								else soundBufCount_ = 0;
							} else if (select > 3 && select < 7) {
								if (toneMode_ == 0) {
									if (tone_preset_[select - 4] < 14) tone_preset_[select - 4]++;
									else tone_preset_[select - 4] = 0;
								} else {
									if (tone_np_[select - 4] < 4) tone_np_[select - 4]++;
									else tone_np_[select - 4] = 0;
								}
							}
							psgi_set();
							writeSP();
							break;
					}
					repaint();
					while (System.currentTimeMillis() - ct < wt) {
						if (getKeypadState() == 0) break;
						try {
							Thread.sleep(10L);
						}
						catch (Exception ex) {}
					}
					wt = 180;
				}
				break;

			case Display.KEY_LEFT :
				while (getKeypadState() != 0) {
					ct = System.currentTimeMillis();
					switch (mode_) {
						case MODE_MENU_ROM :
							if (page_ > 1) page_--;
							else page_ = sdPage_;
							readSdromNameSP(page_);
							break;
						case MODE_MENU_SETTING :
							if (selectSubMenuNo_ == 1){
								if (frameSkip_ > 1) frameSkip_--;
									else frameSkip_ = 30;
								writeSP();
							}
							break;
						case MODE_MENU_AUDIO_SET :
							int select = selectSubMenuNo_ + 1;
							if (select == 1) {
								if (vol_ > 0) vol_ -= 10;
								else vol_ = 100;
							} else if (select == 2) {
								if (soundBufCount_ > 0) soundBufCount_ -= 5;
								else soundBufCount_ = 60;
							} else if (select > 3 && select < 7) {
								if (toneMode_ == 0) {
									if (tone_preset_[select - 4] > 0) tone_preset_[select - 4]--;
									else tone_preset_[select - 4] = 14;
								} else {
									if (tone_np_[select - 4] > 0) tone_np_[select - 4]--;
									else tone_np_[select - 4] = 4;
								}
							}
							psgi_set();
							writeSP();
							break;
					}
					repaint();
					while (System.currentTimeMillis() - ct < wt) {
						if (getKeypadState() == 0) break;
						try {
							Thread.sleep(10L);
						}
						catch (Exception ex) {}
					}
					wt = 180;
				}
				break;

			default :
				break;
		}
	}

	//͎󂯎
	public void processIMEEvent(int type, String text) {
		if (type != IME_COMMITTED) return;
		switch (mode_) {
			case MODE_MENU_ROM :
				// ROM̕ҏW
				text = formatSpace(text, SIZE_ROM_NAME);
				sdRomnm_[selectSubMenuNo_] = text;
				writeSdromNameSP((page_ - 1) * NUM_SDROM + selectSubMenuNo_, text);
				repaint();
				break;

			case MODE_MENU_LOAD :
				// Z[u̕ҏW
				if (text.equals("")) break;
				text = formatSpace(text, SIZE_SAVE_NAME);
				saveStr_[selectSubMenuNo_ ] = text;
				writeSPsaves(selectSubMenuNo_);
				repaint();
				break;
			case MODE_MENU_ROMFILE :
				// ROM̃C|[g
				if (selectSubMenuNo_ == 3 && !text.equals("")) {
					messageStr = "ROM̃C|[g";
					repaint();
					String[] romnm = split(text, '\n');
					DataOutputStream out = null;
					try	{
						out = Connector.openDataOutputStream(
							"scratchpad:///0;pos="
								+ (SIZE_SP_SET)
								+ ",length=" + SIZE_ROM_NAME * MAX_SDROM_PAGE * NUM_SDROM);
						for (int i=0; i<romnm.length; i++) {
							if (i > NUM_SDROM * sdPage_ - 1) break;
							out.write(formatSpace(romnm[i], SIZE_ROM_NAME).getBytes());
						}
						out.flush();
					} catch (Exception e) {
						alert("err writeInportSP: " + e);
					} finally {
						try {
							out.close();
							out = null;
						} catch (Exception ex) {
							out = null;
						}
					}
					messageStr = "";
				}
				repaint();
				break;
			default :
				break;
		}
	}

	public void paint(final Graphics g) {
		try {
			if (mode_ == MODE_GAME) {
				if (displayClear) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, 0, getWidth(), getHeight());
					allG.setFlipMode(Graphics.FLIP_NONE);
					allG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					allG.fillRect(0, 0, getWidth(), getHeight());
					displayClear = false;
				}
				if (flipMode_ == 0) {
					if (!sms_) {
						if (zoom_ == 0) {
							allG.setPixels(-8, 40, 256, 144, core.display(), 6144);
							g.drawImage(allImg, 40, 40, 40, 40, 160, 144);
							//allG.setPixels((240 - 256) / 2, 40, 256, 192, core.display(), 0);
							g.drawImage(img[0], 0, 0);
						} else {
							if (Anti_Alias_) {
								g.setPixels(0, (240 - 232) / 2, 240, 216, core.display(), 0);
							} else {
								allG.setPixels(-8, 40, 256, 144, core.display(), 6144);
								g.drawScaledImage(allImg, 0, (240 - 232) / 2, 240, 216, 40, 40, 160, 144);
							} 
						}
					} else {
						g.setPixels((240 - 256) / 2, (224 - 192) / 2, 256, 192, core.display(), 0);
					}
					// 
					if (messageStr != null) {
						g.setColor(Graphics.getColorOfName(Graphics.BLACK));
						g.fillRect(0, 224, 240, 16);
						g.setColor(Graphics.getColorOfName(Graphics.WHITE));
						g.drawString(messageStr, 4, 224 + BASE_LINE);
						messageStr = null;
					}
				} else {
					switch (flipMode_) {
						case 1 :
							g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
							break;
						case 2 :
							g.setFlipMode(Graphics.FLIP_ROTATE);
							break;
						case 3 :
							g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
							break;
						default :
							break;
					}
					if (!sms_) {
						if (zoom_ == 0) {
							allG.setPixels(-8, 40, 256, 144, core.display(), 6144);
							//allG.setPixels((240 - 256) / 2, (240 - 192 - 16) / 2, 256, 192, core.display(), 0);
							allG.drawImage(img[0], 0, 0);
						} else {
							if (Anti_Alias_) {
								allG.setPixels(0, (240 - 232) / 2, 240, 216, core.display(), 0);
							} else {
								allG.setPixels(-8, 40, 256, 144, core.display(), 6144);
								allG.drawScaledImage(allImg, 0, (240 - 232) / 2, 240, 216, 40, 40, 160, 144);
							}
						}
					} else {
						allG.setPixels((240 - 256) / 2, (224 - 192) / 2, 256, 192, core.display(), 0);
					}
					// 
					if (messageStr != null) {
						allG.setColor(Graphics.getColorOfName(Graphics.BLACK));
						allG.fillRect(0, 224, 240, 16);
						allG.setColor(Graphics.getColorOfName(Graphics.WHITE));
						allG.drawString(messageStr, 4, 224 + BASE_LINE);
						messageStr = null;
					}
					g.drawImage(allImg, 0, 0);
				}
			} else {
				paintRootMenu(g);
				// SDt@CPy[W쐬@Iʂ\Ă_~[t@C쐬B
				if (!firstExec_) {
					messageStr = "_~[t@C(y[W" + sdPage_ + ")쐬";
					setMessage(messageStr);
					createSdfiles(1);
					messageStr = null;
					firstExec_ = true;
					initSoundSettings();
					writeSP();
					repaint();
				}
			}
		} catch (Exception ex) {}
	}

	private void paintRootMenu(final Graphics g) {
		g.lock();
		switch (mode_) {
			case MODE_MENU_ROOT :
				subMenu =
					new String[] {
						"ROMI",
				  		"Xe[g[h",
				  		"Xe[gZ[u",
				  		"Zbg",
				  		"Sʐݒ",
				  		"L[zuݒ",
				  		"pbh@\ݒ",
				  		"̑@\",
						"o[W",
					};
				menu(g, "Cj[", subMenu, selectMenuNo_,
					DEFAULT_FONT.stringWidth("o[W")+20*scale);
				break;

			case MODE_MENU_ROM :
				subMenu = sdRomnm_;
				menu(g, "ROMI (PAGE " + page_ + "/" + sdPage_ + ")", subMenu, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("                              ")+20*scale);
				if (menuBGcolor_ >= 3) {
					messageStr = "(PAGE " + page_ + "/" + sdPage_ + ")";
				}
				break;

			case MODE_MENU_LOAD :
			case MODE_MENU_SAVE :
			case MODE_MENU_EXPORT :
			case MODE_MENU_IMPORT :
				String title = "";
				switch (mode_) {
					case MODE_MENU_LOAD :
						title = "Xe[g[h";
						break;
					case MODE_MENU_SAVE :
						title = "Xe[gZ[u";
						break;
					case MODE_MENU_EXPORT :
						title = "f[^GIFo";
						break;
					case MODE_MENU_IMPORT :
						title = "f[^GIFǍ";
						break;
					default :
						break;
				}
				subMenu = saveStr_;
				menu(g, title, subMenu, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("                                  ")+20*scale);
				break;



			case MODE_MENU_SETTING :
				subMenu = new String[] {
					"FPS\         : " + ON_OFF_STR[!fpsOff_ ? (1) : (0)],
					"t[XLbv    : " + frameSkip_,
					"x(60FPS)   : " + FRAMES_STR[sleep_],
					"NOROMǍ   : " + ON_OFF_STR[startAndLoad_],
					"Q[ʂ̉]    : " + FLIPMODE_STR[flipMode_],
					"TEho        : " + SOFTKEY_SOUND_STR[soundEnable_ ? (1) : (0)].trim(),
					"E\tgL[̋@\  : " + SOFTKEY_STR[rSoftkey_],
					"GGʊg          : " + ON_OFF_STR[zoom_],
					"j[̓    : " + ON_OFF_STR[alpha_ ? (1) : (0)],
					"I[fBIڍאݒ",
					"ROMt@Cݒ",
					"mFbZ[Wݒ"
				};
				menu(g, "Sʐݒ", subMenu, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("E\tgL[̋@\  : pbhݒ")+20*scale);
				break;

			case MODE_MENU_AUDIO_SET :
				String[] gm = toneMode_ == 0 ? GM_PRESET_STR : GM_NP_STR;
				int[] tone = toneMode_ == 0 ? tone_preset_ : tone_np_;
				subMenu = new String[] {
					"o͉          : " + vol_ + "%",
					"t[        : " + soundBufCount_,
					"F[h        : " + SOUND_STR[toneMode_],
					"Ch1-F          : " + gm[ tone[0] ],
					"Ch2-F          : " + gm[ tone[1] ],
					"Ch3-F          : " + gm[ tone[2] ],
					"Ch1-o          : " + ON_OFF_STR[chEnable_[0] ? (1) : (0)],
					"Ch2-o          : " + ON_OFF_STR[chEnable_[1] ? (1) : (0)],
					"Ch3-o          : " + ON_OFF_STR[chEnable_[2] ? (1) : (0)],
					"Ch4-o          : " + ON_OFF_STR[chEnable_[3] ? (1) : (0)],
					"lɖ߂", };
				menu(g, "I[fBIڍאݒ", subMenu, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("Ch1-F          : square 12.5%")+20*scale);
				break;

			case MODE_PAD_SET :
				subMenu = new String[] {
					" L[           : " + KEY_NAME[ keycon_[0] ],
					" L[           : " + KEY_NAME[ keycon_[1] ],
					" L[           : " + KEY_NAME[ keycon_[2] ],
					" L[           : " + KEY_NAME[ keycon_[3] ],
					"{^ 1          : " + KEY_NAME[ keycon_[4] ],
					"{^ 2          : " + KEY_NAME[ keycon_[5] ],
					"PAUSE/START       : " + KEY_NAME[ keycon_[6] ],
					"{^ 1 (2)      : " + KEY_NAME[ keycon_[7] ],
					"{^ 2 (2)      : " + KEY_NAME[ keycon_[8] ],
					"PAUSE/START (2)   : " + KEY_NAME[ keycon_[9] ],
					"GGʊg        : " + KEY_NAME[ keycon_[10] ],
					"Z80̊Ԉ   : " + KEY_NAME[ keycon_[11] ], };
				menu(g, "L[zuݒ", subMenu, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth(" L[           : CAMERA_SELECT")+20*scale);
				break;

			case MODE_MENU_BUTTON_SET :
				subMenu = new String[] {
					"{^ 1 A     : " + ON_OFF_STR[ren1_],
					"{^ 1 z[h : " + ON_OFF_STR[hold1_],
					"{^ 1 ̘Aˁ{z[h",
					"{^ 2 A     : " + ON_OFF_STR[ren2_],
					"{^ 2 z[h : " + ON_OFF_STR[hold2_],
					"{^ 2 ̘Aˁ{z[h",
					"}`pbh@\  : " + CTRL_STR[con2_], };
				menu(g, "pbh@\ݒ", subMenu, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("{^ 1 ̘Aˁ{z[h")+20*scale);
				break;

			case MODE_MENU_TOOLS :
				subMenu =
					new String[] {
						"f[^GIFo",
						"f[^GIFǍ",
						"XN[Vbg",
						"ڂ     : " + ON_OFF_STR[Anti_Alias_ ? (1) : (0)],
						"Z80̊Ԉ: " + ON_OFF_STR[cpuOmit_]
/*
						"ݒGIFo",
						"ݒGIFǍ",
*/
					};
				menu(g, "̑@\", subMenu, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("ڂ     : OFF")+20*scale);
				break;


			case MODE_MENU_ROMFILE :
				subMenu = new String[] {
					"SDt@C쐬(+1y[W)",
					"SDt@C폜(-1y[W)",
					"ROM̂̃GNX|[g",
					"ROM̂̃C|[g",
					"SDJ[h󂫗eʂ̊mF", };
				menu(g, "ROMt@Cݒ :  " + sdPage_ + "PAGE" , subMenu, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("SDt@C쐬(+1y[W)")+20*scale);
				break;
			case MODE_MENU_CONFIRM :
				subMenu =
					new String[] {
						"f[^[h  : " + ON_OFF_STR[confirmMsg_ & 1],
						"f[^Z[u  : " + ON_OFF_STR[(confirmMsg_ & 2) >> 1],
						"Zbg      : " + ON_OFF_STR[(confirmMsg_ & 4) >> 2],
						"I          : " + ON_OFF_STR[(confirmMsg_ & 8) >> 3],
						"Lׂ"
						};
				menu(g, "mFbZ[Wݒ", subMenu, selectSubMenuNo_,
					DEFAULT_FONT.stringWidth("f[^[h  : OFF")+20*scale);
				break;
			default :
				break;
		}
		
		// 
		g.setColor(Graphics.getColorOfName(Graphics.BLACK));
		g.fillRect(0, 224, 240, 16);
		if (messageStr != null) {
			g.setColor(Graphics.getColorOfName(Graphics.WHITE));
			g.drawString(messageStr, 4, 224 + BASE_LINE);
		}
		g.unlock(true);
	}

	/*
	* drawMsg(), drawcTriangle(), drawChs()  Shoelace 炢܂ m(_ _)mZMo[Ŵ̂܂܎gĂ܂B݂܂
	*/
	//bZ[W\GA̕`
	public void drawMsg(final Graphics g, int xp,int yp,int whd,int hgt){
		//bZ[W\̘g`
		int[] x={xp,xp+2,xp+whd-2,xp+whd,xp+whd,xp+whd-2,xp+2,xp,xp};
		int[] y={yp+2,yp,yp,yp+2,yp+hgt-2,yp+hgt,yp+hgt,yp+hgt-2,yp+2};
		int[] x2={xp-1,xp+2,xp+whd-2,xp+whd+1,xp+whd+1,xp+whd-2,xp+2,xp-1,xp-1};
		int[] y2={yp+2,yp-1,yp-1,yp+2,yp+hgt-2,yp+hgt+1,yp+hgt+1,yp+hgt-2,yp+2};

		//bZ[W\lCr[œhԂ
		g.setColor(g.getColorOfRGB(0x33,0x33,0x77,0xCF));
		g.fillRect(xp,yp,whd,hgt);

		//bZ[Wg\
		g.setColor(g.getColorOfRGB(0x88,0x88,0x88));
		g.drawPolyline(x,y,9);
		g.setColor(g.getColorOfRGB(0xCC,0xCC,0xCC));
		g.drawPolyline(x2,y2,9);
	}

	//J[\̕`
	public void drawcTriangle(final Graphics g, int xp,int yp){
		int[] x={xp,xp+6*scale,xp,xp};
		int[] y={yp,yp+4*scale,yp+8*scale,yp};

		g.setColor(g.getColorOfRGB(0xFF,0xFF,0xFF));
		g.fillPolygon(x,y,4);
	}

	//EBhE̕`
	public void drawChs(final Graphics g, String[] sChois, int x, int y, int whd){
		g.setFont(DEFAULT_FONT);
		int myp = y + HEIGHT_LINE;
		drawMsg(g, x,y,whd,(HEIGHT_LINE*sChois.length)+7*scale);
		g.setColor(g.getColorOfRGB(0xFF,0xFF,0xFF));
		for(int i=0; i<sChois.length; i++) g.drawString(sChois[i], x + 17 * scale, myp + (i * HEIGHT_LINE));
	}

	private void menu(final Graphics g, String title, final String[] menu, final int select, final int windowWidth) {
		g.setFont(DEFAULT_FONT);
		g.setColor(Graphics.getColorOfName(Graphics.BLACK));
		g.fillRect(0, 0, getWidth(), getHeight());
		// wiF
		if (alpha_) {
			if (!run_) {
				g.drawImage(img[1], 0, 0);
			} else {
				if (!sms_) {
					if (zoom_ == 0) {
						allG.setPixels(-8, 40, 256, 144, core.display(), 6144);
						g.drawImage(allImg, 40, 40, 40, 40, 160, 144);
						//allG.setPixels((240 - 256) / 2, 40, 256, 192, core.display(), 0);
						g.drawImage(img[0], 0, 0);
					} else {
						if (Anti_Alias_) {
							g.setPixels(0, 0, 240, 216, core.display(), 0);
						} else {
							allG.setPixels(-8, 40, 256, 144, core.display(), 6144);
							g.drawScaledImage(allImg, 0, (240 - 232) / 2, 240, 216, 40, 40, 160, 144);
						} 
					}
				} else {
					g.setPixels((240 - 256) / 2, (224 - 192) / 2, 256, 192, core.display(), 0);
				}
			}
			if ((menuBGcolor_ % 3) == 0) { // 0, 3
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x44, 0xAA));//BLUE -alpha
			} else if ((menuBGcolor_ % 3) == 1) { // 1, 4
				g.setColor(Graphics.getColorOfRGB(0x44, 0x00, 0x22, 0xAA));//RED -alpha
			} else { // 2, 5
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));//BLACK -alpha
			}
		} else {
			if ((menuBGcolor_ % 3) == 0) { // 0, 3
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x55));//BLUE
			} else if ((menuBGcolor_ % 3) == 1) { // 1, 4
				g.setColor(Graphics.getColorOfRGB(0x44, 0x00, 0x22));//RED
			} else { // 2, 5
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));//BLACK
			}
		}
		if (menuBGcolor_ >= 3) {
			g.fillRect(0, 0, MENU_WIDTH, MENU_HEIGHT);
			//ShoelaceEBhE
			int shoeX = 5 * scale;
			int shoeY = 5 * scale;
/*
			if (isReverse())
				shoeX += (MENU_WIDTH - 320 * scale) / 2;
*/
			drawChs(g, menu, shoeX, shoeY, windowWidth);
			drawcTriangle(g, shoeX + 5 * scale, HEIGHT_LINE * (select + 1) - 5 * scale);
		} else {
			g.fillRect(0, HEIGHT_LINE, MENU_WIDTH, MENU_HEIGHT - HEIGHT_LINE - 16 * scale);
			//j[^CgF
			if (menuBGcolor_ == 0) {
				g.setColor(Graphics.getColorOfRGB(0x55, 0x55, 0xAA));
			} else if (menuBGcolor_ == 1) {
				g.setColor(Graphics.getColorOfRGB(0x88, 0x00, 0x44));
			} else {
				g.setColor(Graphics.getColorOfRGB(0xA, 0xF, 0x41));
		   	}
			g.fillRect(0, 0, MENU_WIDTH, HEIGHT_LINE);
			g.setColor(Graphics.getColorOfName(Graphics.BLACK));
			g.drawString(title, 2 * scale, BASE_LINE);
			g.drawString(title, 3 * scale, BASE_LINE - 1 * scale);
			g.drawString(title, 4 * scale, BASE_LINE);
			g.drawString(title, 3 * scale, BASE_LINE + 1 * scale);
			g.setColor(Graphics.getColorOfName(Graphics.WHITE));
			g.drawString(title, 3 * scale, BASE_LINE);

			for (int i = 0; i < menu.length; i++) {
				if (i == select) {
					//Io[̐F
					if (menuBGcolor_ == 0) {
						g.setColor(Graphics.getColorOfRGB(0xdd, 0xdd, 0xff));
					} else if (menuBGcolor_ == 1) {
						g.setColor(Graphics.getColorOfRGB(0xFF, 0xBB, 0xAA));
					} else {
						g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0xC0));
					}
					g.fillRect(0, HEIGHT_LINE * (i + 1), MENU_WIDTH, HEIGHT_LINE);
					//I̕F
				  	if (menuBGcolor_ == 0) {
						g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x88));
					} else if (menuBGcolor_ == 1) {
						g.setColor(Graphics.getColorOfRGB(0x99, 0x33, 0x33));
					} else if (menuBGcolor_ == 2) {
						g.setColor(Graphics.getColorOfRGB(0xff, 0xff, 0xff));
					}
				} else {
					//I̕F
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
				}
				// j[
				String num;
				if (i < 10) {
					num = "[" + (i + 1) % 10 + "] ";
				} else {
					switch (i){
						case 10 :
							num = "[*] ";
							break;
						case 11 :
							num = "[#] ";
							break;
						default :
							num = "[-] ";
							break;
					}
				}
				String romno = "";
				if (mode_ == MODE_MENU_ROM){
					romno = formatNumber((page_ - 1) * NUM_SDROM + i + 1, 3) + " ";
				}
				g.drawString(num + romno + menu[i], 4 * scale, HEIGHT_LINE * (i + 1) + BASE_LINE);
			}
		}
	}

	public void setMessage(final String s) {
		g.lock();
		g.setColor(Graphics.getColorOfName(Graphics.BLACK));
		g.fillRect(0, 224, 240, 16);
		g.setColor(Graphics.getColorOfName(Graphics.WHITE));
		g.drawString(s, 4, 224 + BASE_LINE);
		g.unlock(true);
	}

	private void selectMenuRoot() {
		boolean rYes = true;
		int select = selectMenuNo_ + 1;
		switch (select) {
			case 1 : // ROMI
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
				page_ = sdNo_ / NUM_SDROM + 1;
				selectSubMenuNo_ = sdNo_ % NUM_SDROM;
				readSdromNameSP(page_);
				mode_ = MODE_MENU_ROM;
				break;

			case 2 : // LOAD
				selectSubMenuNo_ = svSubMenuLoadNo;
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_ROM_STR);
				mode_ = MODE_MENU_LOAD;
				break;

			case 3 : // SAVE
				selectSubMenuNo_ = svSubMenuSaveNo;
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_SAVE_STR);
				mode_ = MODE_MENU_SAVE;
				break;

			case 4 : // RESET
				if (run_) {
					if ((confirmMsg_ & 4) != 0) rYes = confirm("Zbg܂H");
					if (rYes) {
						core.request(SMSCore.REQUEST_RESET, 0);
						setRightSoftkeyLabel();
						displayClear = true;
						mode_ = MODE_GAME;
					}
				} else {
					messageStr = "Q[NĂ܂I";
					setMessage(messageStr);
					try {
						Thread.sleep(1000);
					} catch (Exception ex) {}
					messageStr = "";
				}
				break;

			case 5 : // Sʐݒ
				selectSubMenuNo_ = svSubMenuSettingNo;
				setSoftLabel( Frame.SOFT_KEY_2 ,SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
				mode_ = MODE_MENU_SETTING;
				break;

			case 6 : // L[zuݒ
				selectSubMenuNo_ = svSubMenuKeyConfNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_PAD_SET;
				break;

			case 7 : // pbh@\ݒ
				selectSubMenuNo_ = svSubMenuPadNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_BUTTON_SET;
				break;

			case 8 : // ̑@\
				selectSubMenuNo_ = svSubMenuToolNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_TOOLS;
				break;

			case 9 : // o[W
				infomsg(INFO_STR);
				break;

			default :
		}
		repaint();
	}

	private void selectMenuSet() {
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 : // FPS\
				fpsOff_ = !fpsOff_;
				break;

			case 2 : // fs
				if (frameSkip_ < 30) frameSkip_++;
				else frameSkip_ = 1;
				break;

			case 3 : // x
				if (sleep_ < 2) sleep_++;
				else sleep_ = 0;
				break;

			case 4 : // NɑOROMǂݍނ
				startAndLoad_ = (startAndLoad_ + 1) & 1;
				break;

			case 5 : // ʉ]
				if (flipMode_ < 3) flipMode_++;
				else flipMode_ = 0;
				break;

			case 6 : // TEho
				soundEnable_ = !soundEnable_;
				psgi.setSoundEnable(soundEnable_);
				break;

			case 7 : // E\tgL[̋@\
				if (rSoftkey_ < 2) {
					rSoftkey_++;
				} else {
					rSoftkey_ = 0;
				}
				if (rSoftkey_ == 2) {
					skeyMask_ = 0xFFFFFFFF;
				} else {
					skeyMask_ = 0xFFBFFFFF;
				}
				break;

			case 8 : // GGg
				zoom_ = (zoom_ + 1) & 1;
				break;

			case 9 : // j[
				alpha_ = !alpha_;
				break;

			case 10 : // I[fBIڍאݒ
				selectSubMenuNo_ = svSubMenuAudioNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_AUDIO_SET;
				break;

			case 11 : // ROMt@Cݒ
				selectSubMenuNo_ = svSubMenuRomfileNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_ROMFILE;
				break;

			case 12 : // mFbZ[W
				selectSubMenuNo_ = svSubMenuConfirmNo;
				mode_ = MODE_MENU_CONFIRM;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				break;

			default :
				break;
		}
		writeSP();
		repaint();
	}

	private void selectMenuTools() {
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 : // Z[uEXPORT
				svSubMenuToolNo = selectSubMenuNo_;
				selectSubMenuNo_ = svSubMenuExportNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_EXPORT;
				break;

			case 2 : // Z[uIMPORT
				svSubMenuToolNo = selectSubMenuNo_;
				selectSubMenuNo_ = svSubMenuImportNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_IMPORT;
				break;

			case 3 : // XN[Vbg
				svSubMenuToolNo = selectSubMenuNo_;
				messageStr = "ʕۑ";
				repaint();
				saveScreenShot();
				messageStr = "";
				break;

			case 4 : //ڂ
				Anti_Alias_ = !Anti_Alias_;
				break;

			case 5 : // Z80Ԉ
				cpuOmit_ = (cpuOmit_ + 1) & 1;
				core.i_sw(cpuOmit_ == 1);
				break;
/*
			case 4 : // ݒEXPORT
				exportGIF();
				break;

			case 5 : // ݒIMPORT
				importGIF();
				break;
*/
			default :
				break;
		}
		writeSP();
		repaint();
	}

	private void selectMenuSound() {
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 : // 
				if (vol_ < 100) vol_ += 10;
				else vol_ = 0;
				break;

			case 2 : // t[obt@
				if (soundBufCount_ < 60) soundBufCount_ += 5;
				else soundBufCount_ = 0;
				break;

			case 3 : // F[h
				if (toneMode_ < 2) toneMode_++;
				else toneMode_ = 0;
				break;

			case 4 : // F
			case 5 :
			case 6 :
				if (toneMode_ == 0) {
					if (tone_preset_[select - 4] < 14) tone_preset_[select - 4]++;
					else tone_preset_[select - 4] = 0;
				} else {
					if (tone_np_[select - 4] < 4) tone_np_[select - 4]++;
					else tone_np_[select - 4] = 0;
				}
				break;

			case 7 : // o̓`l
			case 8 :
			case 9 :
			case 10 :
				chEnable_[select - 7] = !chEnable_[select - 7];
				break;

			case 11 : // 
				initSoundSettings();
				break;

			default :
		}
		psgi_set();
		writeSP();
		repaint();
	}

	// TEhftHgl
	private void initSoundSettings() {
		vol_ = 100;
		soundBufCount_ = 15;
		toneMode_ = 0;
		tone_preset_[0] = 0;
		tone_preset_[1] = 0;
		tone_preset_[2] = 0;
		tone_np_[0] = 0;
		tone_np_[1] = 0;
		tone_np_[2] = 0;
		for(int i=0;i<4;i++) chEnable_[i] = true;
	}

	private void psgi_set() {
		psgi.setFrameBufCount(soundBufCount_);
		psgi.setSoundEnable(soundEnable_);
		psgi.setMasterVolume(vol_);
		for(int i=0; i<4 ; i++) 
			psgi.setChEnable(i, chEnable_[i]);

		if (toneMode_ == 0) {
			psgi.setMode(PSGi.MODE_PRESET);
			for (int i=0; i<GM_PRESET_NUM.length; i++) psgi.setToneBank(i, GM_PRESET_NUM[i]);
			psgi.setChTone(0, tone_preset_[0]);
			psgi.setChTone(1, tone_preset_[1]);
			psgi.setChTone(2, tone_preset_[2]);
			psgi.setChTone(3, 15);
		} else if (toneMode_ == 1) {
			psgi.setMode(PSGi.MODE_YAMAHA);
			for (int i=0; i<GM_NP_NUM.length; i++) psgi.setToneBank(i, GM_NP_NUM[i]);
			psgi.setChTone(0, tone_np_[0]);
			psgi.setChTone(1, tone_np_[1]);
			psgi.setChTone(2, tone_np_[2]);
			psgi.setChTone(3, 4);
		} else if (toneMode_ == 2) {
			psgi.setMode(PSGi.MODE_ROHM);
			for (int i=0; i<GM_NP_NUM.length; i++) psgi.setToneBank(i, GM_NP_NUM[i]);
			psgi.setChTone(0, tone_np_[0]);
			psgi.setChTone(1, tone_np_[1]);
			psgi.setChTone(2, tone_np_[2]);
			psgi.setChTone(3, 4);
		}
	}

	private void selectMenuKey() {
		messageStr = "L[͂Ă";
		setMessage(messageStr);
		mode_ = MODE_PAD_SET_NOW;
	}

	private void selectMenuPad() {
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 : // {^ 1 A
				ren1_ = (ren1_ + 1) & 1;
				break;

			case 2 : // {^ 1 z[h
				hold1_ = (hold1_ + 1) & 1;
				break;

			case 3 : //{^ 1 ̘Aˁ{z[h
				if (ren1_ != 0 && hold1_ != 0) {
					ren1_ = 0;
					hold1_ = 0;
				} else {
					ren1_ = 1;
					hold1_ = 1;
				}
				break;

			case 4 : // {^2A
				ren2_ = (ren2_ + 1) & 1;
				break;

			case 5 : // {^2z[h
				hold2_ = (hold2_ + 1) & 1;
				break;

			case 6 : //{^ 2 ̘Aˁ{z[h
				if (ren2_ != 0 && hold2_ != 0) {
					ren2_ = 0;
					hold2_ = 0;
				} else {
					ren2_ = 1;
					hold2_ = 1;
				}
				break;

			case 7 : // }`pbh@\
				if (con2_ < 2) con2_++;
				else con2_ = 0;
				break;

			default :
				break;
		}
		repaint();
	}

	private void selectMenuSdset() {
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 : // SDt@C쐬
				if (sdPage_ < MAX_SDROM_PAGE) {
					if (confirm("SDJ[hɃt@C쐬܂H")) {
						sdPage_++;
						messageStr = "_~[t@C(y[W" + sdPage_ + ")쐬";
						setMessage(messageStr);
						createSdfiles(sdPage_);
						writeSP();
						messageStr = "";
					}
				} else {
					infomsg("őy[WɒB܂B");
				}
				break;

			case 2 : // SDt@C폜
				if (sdPage_ > 1) {
					if (confirm("SDJ[h̃t@C폜܂H\n납1y[W" + NUM_SDROM + "t@C폜")) {
						messageStr = "SDt@C(y[W" + sdPage_ + ")폜";
						setMessage(messageStr);
						deleteSdfiles(sdPage_);
						sdPage_--;
						if (sdNo_ > sdPage_ * NUM_SDROM) sdNo_ = 0;
						writeSP();
						messageStr = "";
					}
				} else {
					infomsg("ŏy[WɒB܂B");
				}
				break;

			case 3 : // ROMGNX|[g
				String eXstr = "";
				messageStr = "ROM̃GNX|[g";
				setMessage(messageStr);
				for(int i=0; i<sdPage_; i++) {
					readSdromNameSP(i + 1);
					for(int j=0; j<NUM_SDROM; j++) eXstr = eXstr + sdRomnm_[j].trim() + "\n";
				}
				imeOn(eXstr, TextBox.DISPLAY_ANY, TextBox.KANA);
				messageStr = "";
				break;

			case 4 : // ROMC|[g
				if (confirm("ROM̂C|[g܂H")) {
					imeOn("", TextBox.DISPLAY_ANY, TextBox.KANA);
				}
				break;

			case 5 : // 󂫗eʂ̊mF
				SDbinding sd = new SDbinding();
				long fs = sd.sdGetFreeSize() / 1024;
				infomsg("SDJ[h󂫗eʁF" + fs + "KB");
				break;

			default :
		}
		repaint();
	}

	private void selectMenuConfirm() {
		// mFbZ[W
		int select = selectSubMenuNo_ + 1;
		switch (select) {
			case 1 :
				confirmMsg_ ^= 1;
				break;
			case 2 :
				confirmMsg_ ^= 2;
				break;
			case 3 :
				confirmMsg_ ^= 4;
				break;
			case 4 :
				confirmMsg_ ^= 8;
				break;
			default :
				if ((confirmMsg_ & 0xFF) == 0xF0) {
					confirmMsg_ = 0xFF;
				} else {
					confirmMsg_ = 0xF0;
				}
				break;
		}
		writeSP();
		repaint();
	}

	private void keySet(final int button) {
		if (button == Display.KEY_SOFT2) {
			if (confirm("ׂẴL[zuNA܂H")) {
				for (int i=0; i<keycon_.length; i++) keycon_[i] = 63;
			} else {
				keycon_[ selectSubMenuNo_ ] = 63;
			}
			writeSPkeys();
		} else if (button != Display.KEY_SOFT1) {
			keycon_[ selectSubMenuNo_ ] = button;
			writeSPkeys();
		}
		setSoftLabel(Frame.SOFT_KEY_2, null);
		mode_ = MODE_PAD_SET;
		messageStr = "";
		repaint();
	}

	public int readJoyPad(final int port) {
		int key = getKeypadState() & skeyMask_;
		int[] keyArray = new int[10];

		for (int i=0; i<keyArray.length; i++) keyArray[i] = ((1 << keycon_[i] & key) != 0) ? (1 << i) : 0;
		keyArray[4] |= (keyArray[7] >>> 3); // button 1
		keyArray[5] |= (keyArray[8] >>> 3); // button 2
		keyArray[6] |= (keyArray[9] >>> 3); // Pause / Start

		// AˁAz[h
		if (hold1_ == 1) keyArray[4] ^= 0x10;
		if (ren1_ == 1 && keyArray[4] == 0x10 && frame_count % 4 > 1) keyArray[4] = 0;
		if (hold2_ == 1) keyArray[5] ^= 0x20;
		if (ren2_ == 1 && keyArray[5] == 0x20 && frame_count % 4 > 1) keyArray[5] = 0;

		// PAUSE (SMS)
		if (sms_) core.pause_button(keyArray[6] != 0);

		int input = 0xFF;
		switch (port) {
			case 1 :  // 0xDC
				if (con2_ != 2) input &= ~(keyArray[0] | keyArray[1] | keyArray[2] | keyArray[3] | keyArray[4] | keyArray[5]);
				if (con2_ != 0) input &= ~((keyArray[0] | keyArray[1]) << 6);
				break;
			case 2 :  // 0xDD SMS-ONLY
				if (sms_ && con2_ != 0) input &= ~((keyArray[2] | keyArray[3] | keyArray[4] | keyArray[5]) >>> 2);
				break;
			default : // 0x00 GG-ONLY
				if (!sms_ && con2_ != 2) input &= ~(keyArray[6] << 1);
				break;
		}
		return input;
	}

	private void stateLoad() {
		if(run_) {
			int select = selectSubMenuNo_ + 1;
			String tmp = saveStr_[select - 1].trim();
			if (tmp.equals("")) {
				infomsg("Lȃf[^ł͂܂B");
			} else {
				boolean rYes = true;
				if ((confirmMsg_ & 1) != 0)
					rYes = confirm("No." + select
						+ "\n" + saveStr_[select - 1] + "\n[h܂H");
				if (rYes) {
					messageStr = "f[^[h";
					setMessage(messageStr);
					core.request(SMSCore.REQUEST_LOAD, select);
					setRightSoftkeyLabel();
					messageStr = "";
					displayClear = true;
					mode_ = MODE_GAME;
				}
			}
		} else {
			messageStr = "Q[NĂ܂I";
			setMessage(messageStr);
			try {
				Thread.sleep(1000);
			} catch (Exception ex) {}
			messageStr = "";
		}
		repaint();
	}

	private void stateSave() {
		if (run_) {
			int select = selectSubMenuNo_ + 1;
			boolean rYes = true;
			if ((confirmMsg_ & 2) != 0)
				rYes = confirm("No." + select
				+ "\n"
				+ saveStr_[select - 1]
				+ "\nɃZ[u܂H");
			if (rYes) {
				messageStr = "f[^Z[u";
				setMessage(messageStr);
				writeSaveDate();
				core.request(SMSCore.REQUEST_SAVE, select);
				setRightSoftkeyLabel();
				messageStr = "";
				displayClear = true;
				mode_ = MODE_GAME;
			}
		} else {
			messageStr = "Q[NĂ܂I";
			setMessage(messageStr);
			try {
				Thread.sleep(1000);
			} catch (Exception ex) {}
			messageStr = "";
		}
		repaint();
	}

	private void writeSaveDate() {
		// SaveAGameSPۑ
		Calendar cal = Calendar.getInstance();
		saveStr_[selectSubMenuNo_] = formatSpace(
			formatNumber(cal.get(Calendar.MONTH) + 1, 2)
				+ "/"
				+ formatNumber(cal.get(Calendar.DATE), 2)
				+ " "
			+ formatNumber(cal.get(Calendar.HOUR_OF_DAY), 2)
			+ ":"
			+ formatNumber(cal.get(Calendar.MINUTE), 2)
			+ " "
			+ curRom_, SIZE_SAVE_NAME);
		writeSPsaves(selectSubMenuNo_);
	}

	private void setRightSoftkeyLabel() {
		switch (rSoftkey_) {
			case 0 :
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_PAD_STR);
				break;
			case 1 :
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_RESET_STR);
				break;
			case 2 :
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_SOUND_STR[soundEnable_ ? (1) : (0)]);
				break;
			default :
				setSoftLabel(Frame.SOFT_KEY_2, null);
		}
	}

	private void createSdfiles(final int page) {
		//_~[SDt@C쐬
		int j = (page - 1) * NUM_SDROM + 1;
		SDbinding sd = new SDbinding();
		for(int i = j; i < j + NUM_SDROM; i++) {
			sd.createFile(formatNumber(i, 3)/* + ".sms"*/);
		}
	}

	private void deleteSdfiles(final int page) {
		//_~[SDt@C폜
		int j = (page - 1) * NUM_SDROM + 1;
		SDbinding sd = new SDbinding();
		for(int i = j; i < j + NUM_SDROM; i++) {
			sd.deleteFile(formatNumber(i, 3)/* + ".sms"*/);
			writeSdromNameSP(i - 1, "");
		}
	}

	private void saveScreenShot() {
		//XN[Vbg
		Image ig;
		if(sms_ || zoom_ == 0) {
			ig = Image.createImage(256, 192);
			(ig.getGraphics()).setPixels(0, 0, 256, 192, core.display(), 0);
		} else {
			if (!Anti_Alias_) {
				ig = Image.createImage(240, 216);
				//allG.setPixels(0, 0, 256, 192, core.display(), 0);
				allG.setPixels(-8, 40, 256, 144, core.display(), 6144);
				(ig.getGraphics()).drawScaledImage(allImg,0, 0, 240, 216, 40, 40, 160, 144);
			} else {
				ig = Image.createImage(240, 216);
				(ig.getGraphics()).setPixels(0, 0, 240, 216, core.display(), 0);
			}
		}
		try{
			ImageEncoder ie = ImageEncoder.getEncoder("JPEG");
			ie.setAttribute(0, 0);
			EncodedImage ei;
			if (!sms_) {
				if (zoom_ == 0) {
					ei = ie.encode(ig, 48, 24, 160, 144);
				} else {
					ei = ie.encode(ig, 0, 0, 240, 216);
				}
			} else {
				ei = ie.encode(ig, (256 - 240) / 2 , 0, 240, 192);
			}
			MediaImage mi = ei.getImage();
			mi.use();
			ImageStore.addEntry(mi);
			mi.unuse();
			mi.dispose();
		}catch(Exception e){
			alert("err screenshot: " + e);
		}
	}

	private void loadRom() {
		setMessage("ROMt@Cǂݍݒ");
		SDbinding sd = null;
		InputStream is = null;
		int select = selectSubMenuNo_;
		try {
			ren1_  = 0;
			hold1_ = 0;
			ren2_  = 0;
			hold2_ = 0;
			con2_  = 0;

			// SMSCore̍ċN
			run_ = false;
			core.setRunning(run_);
			core = new SMSCore(this, psgi);
			core.i_sw(cpuOmit_ == 1);
			allG.setColor(Graphics.getColorOfName(Graphics.BLACK));
			allG.fillRect(0, 0, getWidth(), getHeight());

			String fnm = formatNumber((page_ - 1) * NUM_SDROM + select + 1, 3);
			sd = new SDbinding();
			is = sd.openInputStream(fnm);
			if (is != null) {
				int c = core.loadROM(is, sd.length);
				if (c != 0) {
					sdNo_ = (page_ - 1) * NUM_SDROM + select;
					curRom_ = sdRomnm_[select]; // JgROMۑ
					writeSP();
					System.gc();
					messageStr = "";
					setSoftLabel( Frame.SOFT_KEY_1 , SOFTKEY_ROOT_STR );
					setRightSoftkeyLabel();
					displayClear = true;
					mode_ = MODE_GAME;
					sms_ = c == 1;
					core.setSMS(sms_);
					run_ = true;
					core.setRunning(run_);
					core.reset();
					core.start();
					core.request(SMSCore.REQUEST_START, 0);
				} else {
					alert("Lȃt@Cł͂܂B");
				}
			} else {
				if (confirm("ROMt@Cǂݍ߂܂B\n_~[t@Cč쐬܂H\n("
					+ sdPage_ + "y[W" + (sdPage_ * NUM_SDROM) + "t@C)"))
				{
					for (int i = 1; i <= sdPage_; i++) {
						messageStr = "_~[t@C(y[W" + i + ")쐬";
						setMessage(messageStr);
						createSdfiles(i);
					}
				}
				messageStr = "";
				repaint();
			}
		} catch (Exception e) {
			alert("err loadRom: " + e);
		} catch (Error err) {
			alert("err loadRomError: " + err);
			throw err;
		} finally {
			is = null;
			sd.close();
			sd = null;
			//SDbinding.closeFileEntry();
		}
	}

	private void exportGIF() {
		final byte[] GIF_FOOTER = { 0x00, 0x3B };

		SDbinding sd = null;
		DataInputStream in = null;
		try {
			// ScratchPadbyteǂݍ
			byte[] inData = new byte[SIZE_SAVE];
			sd = new SDbinding();
			in = sd.openDataInputStream(getSaveFile(selectSubMenuNo_ + 1));
			if (in == null) {
				alert("t@CǍ݂Ɏs܂B");
				return;
			}
			in.read(inData);

			// ubN쐬
			int blocksSize = inData.length / EXPORT_BLOCK_SIZE;
			int lastBlockLength = inData.length % EXPORT_BLOCK_SIZE;
			boolean lastBlockExists = false;

			if (lastBlockLength != 0) {
				lastBlockExists = true;
			}
			int lastCnt = 0;
			if (lastBlockExists) {
				lastCnt = 1;
			}

			// o̓f[^
			byte[] outData =
				new byte[GIF_HEADER.length
					+ inData.length
					+ blocksSize
					+ lastCnt
					+ GIF_FOOTER.length];

			// GIFwb_
			System.arraycopy(GIF_HEADER, 0, outData, 0, GIF_HEADER.length);
			int outCnt = GIF_HEADER.length;

			// RgubNDataۑ
			int inCnt = 0;
			for (int i = 0; i < blocksSize; i++) {
				// ubNTCY
				outData[outCnt] = EXPORT_BLOCK_SIZE - 0x100;
				outCnt++;

				System.arraycopy(
					inData,
					inCnt,
					outData,
					outCnt,
					EXPORT_BLOCK_SIZE);
				outCnt += EXPORT_BLOCK_SIZE;
				inCnt += EXPORT_BLOCK_SIZE;
			}

			// Ō̃ubN
			if (lastBlockExists) {
				outData[outCnt] = (byte) lastBlockLength;
				outCnt++;

				System.arraycopy(
					inData,
					inCnt,
					outData,
					outCnt,
					lastBlockLength);
				outCnt += lastBlockLength;
				inCnt += lastBlockLength;
			}

			// GIFtb^
			System.arraycopy(GIF_FOOTER, 0, outData, outCnt, GIF_FOOTER.length);

			// GIFo
			//System.out.println("size:" + outData.length);
			//for (int i = 0; i < 100; i++) {
			//	System.out.print(Integer.toHexString(outData[i])  + ", ");
			//}
			//System.out.println("footer:");
			//for (int i = outData.length - 100; i < outData.length; i++) {
			//	System.out.print(Integer.toHexString(outData[i]) + ", ");
			//}

			MediaImage mediaImage = MediaManager.getImage(outData);
			mediaImage.use();
			ImageStore.addEntry(mediaImage);
			mediaImage.unuse();
			mediaImage.dispose();
		} catch (Exception e) {
			alert("err exportGIF: " + e);
		} finally {
			in = null;
			sd.close();
			sd = null;
		}
		//mode_ = MODE_MENU_ROOT;
		messageStr = "";
		repaint();
	}

	private void importGIF() {
		byte[] importData = new byte[SIZE_SAVE];
		int importedSize = 0;

		InputStream is = null;
		try {
			ImageStore istore = ImageStore.selectEntry();
			if (istore == null) {
				return;
			}
			is = istore.getInputStream();

			byte[] header = new byte[6];
			is.read(header);

			// GIF̂
			if (new String(header).equals("GIF89a")) {
				// RgubN܂skip
				is.skip(GIF_HEADER.length - 6);

				int length = is.available();
				//System.out.println("length:" + length);

				boolean last = false;
				while (!last) {
					int size = is.read();
					//System.out.println("size:" + size);
					if (size != EXPORT_BLOCK_SIZE) {
						last = true;
					}

					byte[] block = new byte[size];
					is.read(block);
					if (importedSize + size > importData.length) {
						alert("length is over:" + length);
						return;
					}
					System.arraycopy(block, 0, importData, importedSize, size);
					importedSize += size;
				}
				// tb^͖B
			} else {
				alert("not GIF");
				return;
			}
		} catch (Exception e) {
			alert("err importGIF: " + e);
			return;
		} finally {
			try {
				is.close();
				is = null;
			} catch (Exception ex) {
				is = null;
			}
		}
		
		SDbinding sd = null;
		DataOutputStream out = null;
		try{
			sd = new SDbinding();
			out = sd.openDataOutputStream(getSaveFile(selectSubMenuNo_ + 1));
			if (out == null) {
				alert("t@C݂Ɏs܂B");
			}
			out.write(importData, 0, importData.length);
			out.flush();

			writeSaveDate();

		} catch (Exception e) {
			alert("err importGIF: " + e);
		} finally {
			out = null;
			sd.close();
			sd = null;
		}
		//mode_ = MODE_MENU_ROOT;
		messageStr = "";
		repaint();
	}

	private void readSP()
	{
		DataInputStream in = null;
		DataOutputStream out = null;
		try
		{
			in = Connector.openDataInputStream(
				"scratchpad:///0;pos=0,length="
					+ SIZE_SP_OTHERS);

			// VERSION擾
			int version = in.readInt();
			// NtO
			firstExec_ = in.readBoolean();
			if (version != VERSION)
			{
				in.close();
				in = null;

				out = Connector.openDataOutputStream(
					"scratchpad:///0;pos=0,length="
						+ SIZE_SP_SET);

				byte[] noData = new byte[SIZE_SP_SET];
				for (int i = 0; i < noData.length; i++)
				{
					noData[i] = 0;
				}
				out.write(noData);
				out.flush();
				out.close();

				out = Connector.openDataOutputStream(
					"scratchpad:///0;pos=0,length=5");
				out.writeInt(VERSION);
				out.writeBoolean(firstExec_);
				out.flush();
				out.close();

				in = Connector.openDataInputStream(
					"scratchpad:///0;pos=0,length="
						+ SIZE_SP_OTHERS);
				version = in.readInt();
				firstExec_ = in.readBoolean();
			}
			// fps
			fps_ = in.readInt();
			// fps\
			fpsOff_ = in.readBoolean();
			// t[XLbv
			frameSkip_ = in.readInt();
			// NROMǂݍ
			startAndLoad_ = in.readInt();
			// x
			sleep_ = in.readInt();
			// ʉ]
			flipMode_ = in.readInt();
			// mFbZ[W
			confirmMsg_ = in.readInt();
			if ((confirmMsg_ & 0xF0) == 0) confirmMsg_ = 0xFE;
			// j[wiF
			menuBGcolor_ = in.readInt();
			// j[̓
			alpha_ = in.readBoolean();
			// Z80Ԉ
			cpuOmit_ = in.readInt();
			// GGʊg
			zoom_ = in.readInt();
			//g\Aڂ邩ǂ
			Anti_Alias_ = in.readBoolean();
			// Eķ@\
			rSoftkey_ = in.readInt();
			if (rSoftkey_ == 2) {
				skeyMask_ = 0xFFFFFFFF;
			} else {
				skeyMask_ = 0xFFBFFFFF;
			}
			// 
			vol_ = in.readInt();
			//TEhIIt
			soundEnable_ = in.readBoolean();
			// t[ɍĐ邩
			soundBufCount_ = in.readInt();
			// F[h
			toneMode_ = in.readInt();
			// Fԍ
			tone_preset_[0] = in.readInt();
			tone_preset_[1] = in.readInt();
			tone_preset_[2] = in.readInt();
			tone_np_[0] = in.readInt();
			tone_np_[1] = in.readInt();
			tone_np_[2] = in.readInt();
			// o̓`l
			chEnable_[0] = in.readBoolean();
			chEnable_[1] = in.readBoolean();
			chEnable_[2] = in.readBoolean();
			chEnable_[3] = in.readBoolean();
			// 2PRg[
			con2_ = in.readInt();
			// OSDROMԍ
			sdNo_ = in.readInt();
			// SDt@Cy[W
			sdPage_ = in.readInt();

			/////////////////////////////
			// ftHglݒ
			/////////////////////////////

			if (frameSkip_ == 0) frameSkip_ = 5;
			if (sdPage_ == 0) sdPage_ = 1;

		} catch (Exception e) {
			alert("err readSP: " + e);
		} finally {
			try {
				in.close();
				in = null;
				out.close();
				out = null;
			} catch (Exception ex) {
				in = null;
				out = null;
			}
		}
	}

	private void readSPkeys()
	{
		DataInputStream in = null;
		try
		{
			in = Connector.openDataInputStream(
				"scratchpad:///0;pos="
					+ SIZE_SP_OTHERS
					+ ",length="
					+ SIZE_SP_KEYS);
			for (int i=0; i<keycon_.length; i++)
			{
				keycon_[i] = in.readInt();
			}
			if (!firstExec_) // ǂ@vȂcB
			{
				keycon_ = new int[] {
						Display.KEY_UP,
						Display.KEY_DOWN,
						Display.KEY_LEFT,
						Display.KEY_RIGHT,
						Display.KEY_2,
						Display.KEY_3,
						Display.KEY_6,
						Display.KEY_SELECT,
						63,
						63,
						Display.KEY_1,
						Display.KEY_4, };
				in.close();
				writeSPkeys();
			}
		}
		catch (Exception e)
		{
			alert("err readSPkeys: " + e);
		}
		finally
		{
			try
			{
				in.close();
				in = null;
			}
			catch (Exception ex)
			{
				in = null;
			}
		}
	}

	private void readSPsaves() {
		// Z[u
		DataInputStream in = null;
		try {
			in = Connector.openDataInputStream(
				"scratchpad:///0;pos="
					+ (SIZE_SP_OTHERS + SIZE_SP_KEYS)
					+ ",length="
					+ SIZE_SP_SAVES);
			byte[] save = new byte[SIZE_SAVE_NAME];
			for (int i = 0; i < NUM_SAVE; i++) {
				in.read(save);
				if (save[0] == 0) {
					saveStr_[i] = "";
				} else {
					saveStr_[i] = new String(save);
				}
			}
		} catch (Exception e) {
			alert("err readSPsaves: " + e);
		} finally {
			try {
				in.close();
				in = null;
			} catch (Exception ex) {
				in = null;
			}
		}
	}

	private void readSdromNameSP(final int page) {
		DataInputStream in = null;
		try {
			in = Connector.openDataInputStream(
				"scratchpad:///0;pos="
					+ (SIZE_SP_SET + (SIZE_ROM_NAME * NUM_SDROM) * (page - 1))
					+ ",length=" + SIZE_ROM_NAME * NUM_SDROM);
			byte[] name = new byte[SIZE_ROM_NAME];
			for (int i = 0; i < NUM_SDROM; i++) {
				in.read(name);
				if (name[0] == 0) {
					sdRomnm_[i] = "";
				} else {
					sdRomnm_[i] = new String(name);
				}
			}
		} catch (Exception e) {
			alert("err readSdromNameSP: " + e);
		} finally {
			try {
				in.close();
				in = null;
			}
			catch (Exception ex) {
				in = null;
			}
		}
	}

	private void writeSP() {
		DataOutputStream out = null;
		try {
			out = Connector.openDataOutputStream(
				"scratchpad:///0;pos=0,length=" + SIZE_SP_OTHERS);
			// VERSIONF4byte
			out.writeInt(VERSION);
			// NtO
			out.writeBoolean(firstExec_);
			// fps
			out.writeInt(fps_);
			// fps\
			out.writeBoolean(fpsOff_);
			// t[XLbv
			out.writeInt(frameSkip_);
			// NROMǂݍ
			out.writeInt(startAndLoad_);
			// x
			out.writeInt(sleep_);
			// ʉ]
			out.writeInt(flipMode_);
			// mFbZ[W
			out.writeInt(confirmMsg_);
			// j[wiF
			out.writeInt(menuBGcolor_);
			// j[̓
			out.writeBoolean(alpha_);
			// Z80Ԉ
			out.writeInt(cpuOmit_);
			// GGʊg
			out.writeInt(zoom_);
			//g\Aڂ邩ǂ
			out.writeBoolean(Anti_Alias_);
			// Eķ@\F4byte
			out.writeInt(rSoftkey_);
			// 
			out.writeInt(vol_);
			//TEhIIt
			out.writeBoolean(soundEnable_);
			// t[ɍĐ邩
			out.writeInt(soundBufCount_);
			// F[h
			out.writeInt(toneMode_);
			// Fԍ
			out.writeInt(tone_preset_[0]);
			out.writeInt(tone_preset_[1]);
			out.writeInt(tone_preset_[2]);
			out.writeInt(tone_np_[0]);
			out.writeInt(tone_np_[1]);
			out.writeInt(tone_np_[2]);
			// o̓`l
			out.writeBoolean(chEnable_[0]);
			out.writeBoolean(chEnable_[1]);
			out.writeBoolean(chEnable_[2]);
			out.writeBoolean(chEnable_[3]);
			// 2PRg[
			out.writeInt(con2_);
			// OSDROMԍ
			out.writeInt(sdNo_);
			// SDt@Cy[W
			out.writeInt(sdPage_);
		} catch (Exception e) {
			alert("err writeSP: " + e);
		} finally {
			try {
				out.close();
				out = null;
			} catch (Exception ex) {
				out = null;
			}
		}
	}

	private void writeSPkeys() {
		DataOutputStream out = null;
		try {
			out = Connector.openDataOutputStream(
				"scratchpad:///0;pos="
					+ SIZE_SP_OTHERS
					+ ",length="
					+ SIZE_SP_KEYS);
			for (int i = 0; i < keycon_.length; i++) {
				out.writeInt(keycon_[i]);
			}
			out.flush();
		} catch (Exception e) {
			alert("err writeSPkeys: " + e);
		} finally {
			try {
				out.close();
				out = null;
			} catch (Exception ex) {
				out = null;
			}
		}
	}

	private void writeSPsaves(final int sno) {
		// Z[u
		DataOutputStream out = null;
		try {
			out = Connector.openDataOutputStream(
				"scratchpad:///0;pos="
					+ (SIZE_SP_OTHERS + SIZE_SP_KEYS + SIZE_SAVE_NAME * sno)
					+ ",length="
					+ SIZE_SAVE_NAME);
			byte[] data = formatSpace(saveStr_[sno], SIZE_SAVE_NAME).getBytes();
			out.write(data);
		} catch (Exception e) {
			alert("err writeSPsaves: " + e);
		} finally {
			try {
				out.close();
				out = null;
			} catch (Exception ex) {
				out = null;
			}
		}
	}

	private void writeSdromNameSP(final int sdno, final String romnm) {
		// SDRomF30
		DataOutputStream out = null;
		try {
			out = Connector.openDataOutputStream(
				"scratchpad:///0;pos="
					+ (SIZE_SP_SET + SIZE_ROM_NAME * sdno)
					+ ",length=" + SIZE_ROM_NAME);
			out.write(formatSpace(romnm, SIZE_ROM_NAME).getBytes());
		} catch (Exception e) {
			alert("err writeSdromNameSP: " + e);
		} finally {
			try {
				out.close();
				out = null;
			} catch (Exception ex) {
				out = null;
			}
		}
	}

	/////////////////////////////////
	// Utility Method
	/////////////////////////////////

	public void alert(final String s) {
		while (getKeypadState() != 0) {
			try {
				Thread.sleep(10L);
			} catch (Exception ex) {}
		}
		Dialog dialog = new Dialog(Dialog.DIALOG_ERROR, "G[I");
		dialog.setText(s);
		dialog.show();
		messageStr = "";
	}

	public void infomsg(final String s) {
		while (getKeypadState() != 0) {
			try {
				Thread.sleep(10L);
			} catch (Exception ex) {}
		}
		Dialog dialog = new Dialog(Dialog.DIALOG_INFO , "");
		dialog.setText(s);
		dialog.show();
	}

	private boolean confirm(final String s) {
		while (getKeypadState() != 0) {
			try {
				Thread.sleep(10L);
			}
			catch (Exception ex) {}
		}
		Dialog dialog = new Dialog(Dialog.DIALOG_YESNO, "mF");
		dialog.setText(s);
		boolean ret = (dialog.show() == Dialog.BUTTON_YES);
		return ret;
	}

	private int incNo(int no, final int add, final int max) {
		no += add;
		if (no < 0) {
			no += max;
		}
		no %= max;
		return no;
	}



	private String formatNumber(final int num, final int size) {
		String str = String.valueOf(num);
		while (str.length() < size) {
			str = "0" + str;
		}
		return str;
	}

	private String formatSpace(final String str, final int size) {
		String ret;
		byte[] inbyte = str.getBytes();
		if (inbyte.length > size) {
			ret = new String(inbyte, 0, size);
		} else {
			ret = str;
		}
		while (ret.getBytes().length < size) {
			ret = ret.concat(" ");
		}
		return ret;
	}

	private String[] split(String fromstr, char sptc) {
		int idx1 = 0 , idx2 = 0, i;
		String[] splt = new String[240];
		for(i=0; idx2<fromstr.length() - 1; i++) {
			if (i > 240) break;
			idx2 = fromstr.indexOf(sptc, idx1);
			if(idx2 == -1) idx2 = fromstr.length() - 1;
			splt[i] = fromstr.substring(idx1, idx2);
			idx1 = idx2+1;
		}
		String[] re = new String[i];
		for(int j=0; j<re.length; j++) re[j] = splt[j];
		return re;
	}
}